using System;
using System.Linq;
using DevExpress.ExpressApp;
using DevExpress.Data.Filtering;
using DevExpress.Persistent.Base;
using DevExpress.ExpressApp.Updating;
using DevExpress.Xpo;
using DevExpress.ExpressApp.Xpo;
using DevExpress.Persistent.BaseImpl;
using Xafari.Security.DC;
using DevExpress.ExpressApp.Security;
using TesteSegurancaXafari.Module.Security;

namespace TesteSegurancaXafari.Module.DatabaseUpdate {
    // For more typical usage scenarios, be sure to check out http://documentation.devexpress.com/#Xaf/clsDevExpressExpressAppUpdatingModuleUpdatertopic
    public class Updater : ModuleUpdater {
        public Updater(IObjectSpace objectSpace, Version currentDBVersion) :
            base(objectSpace, currentDBVersion) {
        }
        public override void UpdateDatabaseAfterUpdateSchema() {
            base.UpdateDatabaseAfterUpdateSchema();

            IDCSecuritySystemRole adminRole = ObjectSpace.FindObject<IDCSecuritySystemRole > (
                   new BinaryOperator("Name", SecurityStrategy.AdministratorRoleName));
            if (adminRole == null)
            {
                adminRole = ObjectSpace.CreateObject<IDCSecuritySystemRole>();
                adminRole.Name = SecurityStrategy.AdministratorRoleName;
                adminRole.IsAdministrative = true;
            }
            IDCUser adminUser = ObjectSpace.FindObject<IDCUser>(
                new BinaryOperator("UserName", "admin"));
            if (adminUser == null)
            {
                adminUser = ObjectSpace.CreateObject<IDCUser>();
                adminUser.UserName = "admin";
                adminUser.SetPassword("");
                adminUser.Roles.Add(adminRole);
                adminUser.IsActive = true;
            }
        }
        public override void UpdateDatabaseBeforeUpdateSchema() {
            base.UpdateDatabaseBeforeUpdateSchema();
        }
    }
}
