using System;
using System.Text;
using System.Linq;
using DevExpress.ExpressApp;
using System.ComponentModel;
using DevExpress.ExpressApp.DC;
using System.Collections.Generic;
using DevExpress.Persistent.Base;
using DevExpress.ExpressApp.Model;
using DevExpress.ExpressApp.Actions;
using DevExpress.ExpressApp.Editors;
using DevExpress.ExpressApp.Updating;
using DevExpress.ExpressApp.Model.Core;
using DevExpress.ExpressApp.Model.DomainLogics;
using DevExpress.ExpressApp.Model.NodeGenerators;
using TesteSegurancaXafari.Module.BusinessObjects;
using TesteSegurancaXafari.Module.Security;

namespace TesteSegurancaXafari.Module {
    // For more typical usage scenarios, be sure to check out http://documentation.devexpress.com/#Xaf/clsDevExpressExpressAppModuleBasetopic.
    public sealed partial class TesteSegurancaXafariModule : ModuleBase {
        public TesteSegurancaXafariModule() {
            InitializeComponent();
        }
        public override IEnumerable<ModuleUpdater> GetModuleUpdaters(IObjectSpace objectSpace, Version versionFromDB) {
            ModuleUpdater updater = new DatabaseUpdate.Updater(objectSpace, versionFromDB);
            return new ModuleUpdater[] { updater };
        }
        public override void Setup(XafApplication application) {
            XafTypesInfo.Instance.RegisterEntity("Produto", typeof(IProduto));
            XafTypesInfo.Instance.RegisterEntity("Categoria", typeof(ICategoria));

            XafTypesInfo.Instance.RegisterEntity("Usuario", typeof(IDCUser));
            base.Setup(application);
            // Manage various aspects of the application UI and behavior at the module level.
        }
    }
}
